package dk.vajhoej.record.edit;

import dk.vajhoej.record.StructInfo;

class DataManager {
	private Class<?> clz;
	private StructInfo si;
	private int pos;
	private int recsiz;
	private FileAccess fa;
	public DataManager(Class<?> clz, StructInfo si, FileAccess fa) {
		this.clz = clz;
		this.si = si;
		pos = 0;
		recsiz = si.getLength();
		this.fa = fa;
	}
	public void forward() {
		pos += recsiz;
	}
	public void backward() {
		if(pos >= recsiz) {
			pos -= recsiz;
		}
	}
	@SuppressWarnings({ "rawtypes", "unchecked" })
	public void read(FieldBase[] fb) {
		try {
			Object o = fa.read(pos, recsiz, clz);
			for(int i = 0; i < fb.length; i++) {
				fb[i].setValue(si.getFields().get(i).getField().get(o));
			}
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
	public void write(FieldBase<?>[] fb) {
		try {
			Object o = clz.newInstance();
			for(int i = 0; i < fb.length; i++) {
				si.getFields().get(i).getField().set(o, fb[i].getValue());
			}
			fa.write(pos, o);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}
}
