package dk.vajhoej.record.edit;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.RandomAccessFile;

import dk.vajhoej.record.RecordException;
import dk.vajhoej.record.StructReader;
import dk.vajhoej.record.StructWriter;

class FileAccess {
	private RandomAccessFile raf;
	public FileAccess(String filename) throws FileNotFoundException {
		raf = new RandomAccessFile(filename, "rw");
	}
	public Object read(int pos, int recsiz, Class<?> clz) throws IOException, RecordException, IllegalArgumentException, IllegalAccessException {
		byte[] buf = new byte[recsiz];
		raf.seek(pos);
		raf.read(buf);
		StructReader sr = new StructReader(buf);
		return sr.read(clz);
	}
	public void write(int pos, Object o) throws IllegalArgumentException, IllegalAccessException, RecordException, IOException {
		StructWriter sw = new StructWriter();
		sw.write(o);
		raf.seek(pos);
		raf.write(sw.getBytes());
	}
	public void close() throws IOException {
		raf.close();
	}
}
